/*======================================================================*\
|| #################################################################### ||
|| # Copyright 2006-2009 Youjoomla.com. All Rights Reserved.           ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------- THIS IS NOT FREE SOFTWARE ---------------- #      ||
|| # http://www.youjoomla.com | http://www.youjoomla.com/license.html # ||
|| #################################################################### ||
\*======================================================================*/
/**
 * YJNF4 - Joomla news flash with multi navigation display
 * @version		2.0.2
 * @MooTools version 1.3,1.4
 * @Copyright Youjoomla.com
 * @author		Constantin Boiangiu <info [at] constantinb.com>
 */
var YJNF4 = new Class({	
	Implements: [Options],
	options: {
            overallContainer: null,
            slicesClass: null,
            slicesContainer: null
	},
	
	initialize: function(options){
		this.setOptions(options);
		this.elements = $$(this.options.elements);
		this.start();	
	},   
    start: function(){
       
        this.currentSlice = 0;
        this.overalContainer = $(this.options.overallContainer);
        this.startSlices();
       
    },
   
    startSlices: function(){
       
        this.slices = this.overalContainer.getElements(this.options.slicesClass);
       
        this.cntEff = new Fx.Morph($(this.options.slicesContainer), {wait:false, duration:400 });
        this.slices[0].setStyle('display','block');   
       
        var fromH = this.slices[0].getSize();
        $(this.options.slicesContainer).setStyle('height', fromH.y);
       
        this.setNav();
       
    },
   
    setNav: function(){
       
        var totalSlices = this.slices.length;
        if( totalSlices == 1 ) return;
       
        var linksContainer = new Element('div').setProperty('class','yjnf4_navigation').
                                inject(this.overalContainer);

       
        this.slices.each(function(slice, i){
           
            var n = i+1;
           // var display = new Element('span', {class: 'pagination_yjn'}).set('html','+ n +');
           var display = new Element('span').setProperty('class','pagination_yjn').set('html',n);
            this.slices[i]['fx'] = new Fx.Morph(slice, {duration: 400, transition: Fx.Transitions.Sine.easeOut, wait:false});
           
            if( i == this.currentSlice )
                display.addClass('pagination_yjn_on');
                       
            new Element('a').
                inject(linksContainer).
                adopt(display).
                addEvent('click', function(event){
                    event.stop();
                    if( i==this.currentSlice ) return;
                    this.changeSlice(i);
                }.bind(this));
        }.bind(this))   
       
        this.spans = linksContainer.getElements('span.pagination_yjn');       
    },
   
    changeSlice: function(slice){
       
        this.spans.removeClass('pagination_yjn_on');
        this.spans[slice].addClass('pagination_yjn_on');
       
        var fromH = this.slices[this.currentSlice].getSize();
       
        this.slices[this.currentSlice].setStyles({'display':'none','opacity':0.4});
        this.slices[slice].setStyles({'display':'block'});
       
        var toH = this.slices[slice].getSize();
       
        this.slices[slice]['fx'].start({
            'opacity':[0.4,1]
        });       
        this.cntEff.start({ 'height':[ fromH.y,  toH.y ] });
        this.currentSlice = slice;
       
    }
   
});